質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.12%

build.gradleのビルド処理(非コンパイルエラー)

解決済

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 1,113

KotBig

score 6

前書き

IntelliJ IDEA でKotlinプログラムを組み始めた初心者です。
Kotlinに触れる前はC言語で書いていて、
mainClass以外のファイルも扱うプログラミングは、Kotlinが初めてです。

コードを書く前のビルド:同期化(?) の段階で下記エラーを吐かれ、紹介されたURLへ飛んでも原因が分かりません。
また、自分で書いたものでなく新規プロジェクト作成時に自動的に書かれたものであるため、何をしているのかすら分からず、手詰まり気味です。

Kotlinタグで投稿しましたが、このプログラム自体がKotlinなのかも分かりません。

「分からない」づくしで大変ですが、解決策を提示して貰えませんか。よろしくお願いします。

エラー内容

Caused by: org.codehaus.groovy.control.MultipleCompilationErrorsException: startup failed:
build file 'D:\AppProjects\Program\build.gradle': 5: all buildscript {} blocks must appear before any plugins {} blocks in the script

See https://docs.gradle.org/4.4/userguide/plugins.html#sec:plugins_block for information on the plugins {} block

 @ line 5, column 1.
   buildscript {
   ^

1 error

コード本体

plugins {
        id 'org.jetbrains.kotlin.jvm' version '1.3.20'
}


buildscript {

    ext.kotlin_version = "1.2.60"
    ext.tornadofx_version = "1.7.17"
    ext.junit_version = "5.1.0"

    repositories {
        mavenLocal()
        mavenCentral()
    }


}

apply plugin: "kotlin"
apply plugin: "application"
apply plugin: "org.junit.platform.gradle.plugin"

compileKotlin {
    kotlinOptions.jvmTarget = "1.8"
}

repositories {
    mavenLocal()
    mavenCentral()
    maven {
        url "https://oss.sonatype.org/content/repositories/snapshots/"
    }
}

dependencies {
    compile "org.jetbrains.kotlin:kotlin-stdlib-jdk8:$kotlin_version"

    compile "no.tornado:tornadofx:$tornadofx_version"

    testCompile "org.junit.jupiter:junit-jupiter-api:$junit_version"
    testRuntime "org.junit.jupiter:junit-jupiter-engine:$junit_version"
}

mainClassName = "com.example.demo.app.MyApp"

jar {
    manifest {
        attributes(
                "Class-Path": configurations.compile.collect { it.getName() }.join(" "),
                "Main-Class": mainClassName
        )
    }
    from(configurations.compile.collect { entry -> zipTree(entry) }) {
        exclude "META-INF/MANIFEST.MF"
        exclude "META-INF/*.SF"
        exclude "META-INF/*.DSA"
        exclude "META-INF/*.RSA"
    }
}
group 'Program'
version '1.0-SNAPSHOT'

repositories {
    mavenCentral()
}

dependencies {
    implementation "org.jetbrains.kotlin:kotlin-stdlib-jdk8"
}

compileKotlin {
    kotlinOptions.jvmTarget = "1.8"
}
compileTestKotlin {
    kotlinOptions.jvmTarget = "1.8"
}


プログラム名:'Program'
mainClass:MyApp

としています。

試行事項

エラー文> all buildscript {} blocks must appear before any plugins {} blocks in the script

とのことなので、plugins{} を buildscript{} の後方に配置したり、buildscript{} 内の末尾に配置したり等してビルドを試しましたが、ビルドは速攻終了, エラー文は変わらずといった感じです。

バージョン情報等

IntelliJ IDEA Community Edition 2018.2.4

追記(2019/02/11 20:05)

どうやら、Android Studio によって buildscript 等が生成されたようです。
Kotlin, TornadoFXなども同様に試してみましたが、Android Studio でのみエラーが発生することが確認できました。

Gradle プロジェクトの同期に失敗しました。基本的な機能(編集、デバッグなど)は正しく機能しません。
No cached version of org.jetbrains.kotlin:kotlin-gradle-plugin:1.3.21 available for offline mode.
Disable Gradle 'offline mode' and sync project
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+1

プロジェクト作成のときにどのような作業を行ったのでしょうか?単純なKotlinプログラムを書くのであれば、下図のようにNew Projectの左ペインでKotlinを選び、右ペインでKotlin/JVMを選べば良いと思います。

New Project

質問に記された状況を見る限りでは、Gradleプロジェクトとして作成されたように思います。Gradleをビルドシステムとする場合、ビルドルールを記述するビルドスクリプトが用意されます。質問に記述された「コードらしきもの」は、そのGradleのビルドスクリプトですね。

GradleプロジェクトとしてKotlinアプリケーションを作ることも当然できますが、それは次のステップでは。


私の手元で、New Projectの画面でGradleを選び、Kotlin (Java) のみにチェックを入れてプロジェクトを新規作成したときのbuild.gradleを調べると、

plugins {
    id 'org.jetbrains.kotlin.jvm' version '1.3.21'
}

group 'com.example.kotlin'
version '1.0-SNAPSHOT'

repositories {
    mavenCentral()
}

dependencies {
    implementation "org.jetbrains.kotlin:kotlin-stdlib-jdk8"
}

compileKotlin {
    kotlinOptions.jvmTarget = "1.8"
}
compileTestKotlin {
    kotlinOptions.jvmTarget = "1.8"
}


この程度の内容しかないんですよね。ご提示いただいたような複雑な内容はどこから出てきたのでしょうか。既存GradleプロジェクトにKotlinを追加したいという質問だったのかな?

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/02/04 12:10

    GUIプログラムの簡略化のためにGradleプロジェクトとして作成していたことを説明不足でした。
    SceneBuilder等を使用する予定でしたが、もう少し理解を深めてから再挑戦します。
    ありがとうございました。

    キャンセル

  • 2019/02/11 20:11

    Intellij IDEA 内の Android Studio(追加プラグイン)によるGradleプロジェクト(:Kotlin使用)であることが確認できました。
    詳しくは、追記(2019/02/11 20:00) をご確認下さい。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.12%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る